; phat2 - norecess.condense

;
flipScreen
    	ld a, ( pageFlip )
    	or a
    	jp z, showPage2
showPage1    
    	ld hl, flipOverscan1
    	dec a
    	jp showPage
showPage2
   	ld hl, flipOverscan2
    	inc a
showPage
    	ld ( pageFlip ), a
    	call setCrtc
    	ret
    
; OUT a <> 0 page is flipped
isScreenFlipped
	ld a, ( pageFlip )
	ret

; OUT hl = screen ptr
getScreenPtr
	ld a, ( pageFlip )
	or a
	jp z, screenPtr2
screenPtr1
	ld hl, &8000 ; + &4000 - 24
	ret
screenPtr2
	ld hl, &C000 ; + &4000 - 24
	ret	

; OUT hl = screen ptr (top)
; OUT de = screen ptr (bottom)
getScreenPtrOverscan
	ld a, ( pageFlip )
	or a
	jp z, screenPtrOverscan2
screenPtrOverscan1
	ld hl, &7800 - 384
	ld bc, - &800
	ld a, ( cacheType )
	or a
	jp z, endScreenPtrOverscan1_loop
screenPtrOverscan1_loop
	add hl, bc
	dec a
	jp nz, screenPtrOverscan1_loop
endScreenPtrOverscan1_loop
	ld de, &3800
	ex de, hl
	ret
screenPtrOverscan2
	ld hl, &F800 - 384
	ld bc, - &800
	ld a, ( cacheType )
	or a
	jp z, endScreenPtrOverscan2_loop
screenPtrOverscan2_loop
	add hl, bc
	dec a
	jp nz, screenPtrOverscan2_loop
endScreenPtrOverscan2_loop
	ld de, &B800
	ex de, hl
	ret	

; IN hl = src
setCrtc
	ld b, &bc
	ld a, ( hl )
	or a
	ret z	
	ld c, a
	out (c), c
	inc hl
	ld a, ( hl )
	inc hl
	inc b
	ld c, a
	out (c), a	
	jp setCrtc

;
setCrtcHorizontal
	ld hl, crtcHorizontal
	call setCrtc
	ld hl, flipHorizontal1
	ld ( showPage1 + 1 ), hl
	ld hl, flipHorizontal2
	ld ( showPage2 + 1 ), hl
	ret

;
setCrtcOverscan
	ld hl, crtcOverscan
	call setCrtc
	ld hl, flipOverscan1
	ld ( showPage1 + 1 ), hl
	ld hl, flipOverscan2
	ld ( showPage2 + 1 ), hl
	ret	

;
pageFlip
	defb 0

;
flipHorizontal1
	defb 12, &2c
	defb 13, &0
	defb 0
flipHorizontal2
	defb 12, &3c
	defb 13, &0
	defb 0

;
flipOverscan1
	defb 12, &0c
	defb 13, &20
	defb 0
flipOverscan2
	defb 12, &2c
	defb 13, &20
	defb 0

;
crtcHorizontal
	defb 1, 30 ; 44
	defb 2, 41 ; 48
	;defb 9, 7
    	;defb 4, 38
    	;defb 5, 0
	;defb 9, 6
 ;   	defb 4, 44
 ;   	defb 5, 4
	defb 6, 33 ; 23
	;defb 7, 29
	defb 7, 34 ; 32
 	defb 0

;
crtcOverscan
	defb 1, 48
	defb 2, 50
	defb 6, 38
	defb 7, 40
    	defb 9, 6
    	defb 4, 44
    	defb 5, 4
	defb 0
    