/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * lwoinittri.c - LWO Object Triangles Initializer                            *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "system/file.h"
#include "system/mem.h"
#include "texture/tex.h"
#include "lightwave/lwo/lwo.h"
#include "lightwave/lwo/lwoinit.h"
#include "lightwave/lwo/lwoinittri.h"

/*---------------------------------------------------------------------------- ALLOC */
void 
LwoSurfAllocTriTable(void)
{
    INT32 tri = 0;
    INT32 poly = 0;
    INT32 surfTriCount = 0;
    
    surfTriCount = 0;

    for (tri=0; tri<initLwo->triExCount; tri++)
    {
        poly = initLwo->triExTable[tri].polyIndex;

        if (initLwo->polyTable[poly].surfIndex==initSurf)
        {
            surfTriCount++;
        }
    }

    initLwo->surfTable[initSurf].triCount = surfTriCount;

    initLwo->surfTable[initSurf].triTable = MemAlloc(sizeof(Tri)*initLwo->surfTable[initSurf].triCount);
}

/*---------------------------------------------------------------------------- BUILD TABLE */
void 
LwoSurfBuildTriTable(void)
{
    INT32 tri = 0;
    INT32 poly = 0;
    INT32 surfTriCount = 0;    
    Tri *initLwoTri = NULL;
    
    surfTriCount = 0;

    for (tri=0; tri<initLwo->triExCount; tri++)
    {
        poly = initLwo->triExTable[tri].polyIndex;

        if (initLwo->polyTable[poly].surfIndex==initSurf)
        {
            initLwoTri = &initLwo->surfTable[initSurf].triTable[surfTriCount];
            
            initLwoTri->vert1Index = initLwo->triExTable[tri].vert1Index;
            initLwoTri->vert2Index = initLwo->triExTable[tri].vert2Index;
            initLwoTri->vert3Index = initLwo->triExTable[tri].vert3Index;

            surfTriCount++;
        }
    }
}
