/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * lwoparsepnts.c - LWO Object Vertices Parser                                *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "texture/tex.h"
#include "system/mem.h"
#include "system/file.h"
#include "lightwave/lwo/lwo.h"
#include "lightwave/lwo/lwoparse.h"
#include "lightwave/lwo/lwoparsetools.h"
#include "lightwave/lwo/lwoparsepnts.h"

/*---------------------------------------------------------------------------- VERTICES */
void 
LwoParseVert(void)
{
    INT32 a = 0;
    INT32 b = 0;
    INT32 c = 0;
    INT32 i = 0;

    chunkSize >>= 2;

    lwoCurr->vertCount = chunkSize/3;
    lwoCurr->vertTable = MemAlloc(sizeof(Vert)*lwoCurr->vertCount);
    
    i = 0;

    while (i<lwoCurr->vertCount)
    {
        a = LwoGetUINT32();
        b = LwoGetUINT32();
        c = LwoGetUINT32();

        lwoCurr->vertTable[i].x = *(FLOAT32 *) &a;
        lwoCurr->vertTable[i].y = *(FLOAT32 *) &b;
        lwoCurr->vertTable[i].z = -*(FLOAT32 *) &c;

        i++;
    }
}

/*---------------------------------------------------------------------------- BOUNDING BOX */
void 
LwoParseBounBox(void)
{
    INT32 i = 0;

    i = LwoGetUINT32(); lwoCurr->bBox.minX = *(FLOAT32 *) &i;
    i = LwoGetUINT32(); lwoCurr->bBox.minY = *(FLOAT32 *) &i;
    i = LwoGetUINT32(); lwoCurr->bBox.minZ = *(FLOAT32 *) &i;
    i = LwoGetUINT32(); lwoCurr->bBox.maxX = *(FLOAT32 *) &i;
    i = LwoGetUINT32(); lwoCurr->bBox.maxY = *(FLOAT32 *) &i;
    i = LwoGetUINT32(); lwoCurr->bBox.maxZ = *(FLOAT32 *) &i;
}
