/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * lwoparsepols.c - LWO Object Polygon Parser                                 *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "system/mem.h"
#include "texture/tex.h"
#include "system/file.h"
#include "lightwave/lwo/lwo.h"
#include "lightwave/lwo/lwoparse.h"
#include "lightwave/lwo/lwoparsetools.h"
#include "lightwave/lwo/lwoparsepols.h"

/*---------------------------------------------------------------------------- POLY */
void 
LwoParsePoly(void)
{
    INT32 typeID = 0;
    INT32 i = 0;
    INT32 tmpOffset = 0;
    INT32 offset = 0;
    
    typeID = LwoGetUINT32();             

    switch (typeID)
    {
    case CHUNK('F','A','C','E'):
        {   
            INT32 poly = 0;
            INT32 triEx = 0;
            INT32 count = 0;
            INT32 vert1 = 0;
            INT32 vert2 = 0;
            INT32 vert3 = 0;

            lwoCurr->triExCount = 0;
            lwoCurr->triExTable = MemAlloc(sizeof(TriEx)*(chunkSize>>1));

            poly = 0;
            triEx = 0;

            offset = 4;

            while (offset<chunkSize)
            {
                tmpOffset = GET_OFFSET;

                lwoCurr->polyTable[poly].triOffset = triEx;

                count = LwoGetUINT16()&1023;

                if (count>2)
                {
                    vert1 = LwoGetVX();
                    vert2 = LwoGetVX();

                    i = 0;

                    while (i<count-2)
                    {
                        vert3 = LwoGetVX();

                        lwoCurr->triExTable[triEx].polyIndex = poly;
                        lwoCurr->triExTable[triEx].vert1Index = vert1;
                        lwoCurr->triExTable[triEx].vert2Index = vert2;
                        lwoCurr->triExTable[triEx].vert3Index = vert3;

                        vert2 = vert3;
                        
                        triEx++;

                        i++;
                    }
                }
                else if(count>1)
                {
                    vert1 = LwoGetVX();
                    vert2 = LwoGetVX();

                    lwoCurr->triExTable[triEx].polyIndex = poly;
                    lwoCurr->triExTable[triEx].vert1Index = vert1;
                    lwoCurr->triExTable[triEx].vert2Index = vert1;
                    lwoCurr->triExTable[triEx].vert3Index = vert2;

                    triEx++;
                }
                else
                {
                    vert1 = LwoGetVX();

                    lwoCurr->triExTable[triEx].polyIndex = poly;
                    lwoCurr->triExTable[triEx].vert1Index = vert1;
                    lwoCurr->triExTable[triEx].vert2Index = vert1;
                    lwoCurr->triExTable[triEx].vert3Index = vert1;

                    triEx++;
                }

                lwoCurr->polyTable[poly].triCount = triEx-lwoCurr->polyTable[poly].triOffset;

                poly++;

                offset += GET_OFFSET-tmpOffset;
            }

            lwoCurr->triExCount = triEx;
        }
        break;

    default:
        SKIP_INT8(chunkSize-4);
        break;
    }
}

/*---------------------------------------------------------------------------- POLY -> SURFACE LINK */
void 
LwoParsePolyGetSurf(void)
{
    INT32 poly = 0;
    INT32 surf = 0;
    INT32 i = 0;
	INT32 j = 0;

    subChunkID = LwoGetUINT32();

    switch (subChunkID)
    {
    case CHUNK('S','U','R','F'):
        i = 4;

        while (i<chunkSize)
        {
            j = GET_OFFSET;

			poly = LwoGetVX();
            surf = LwoGetUINT16();

            lwoCurr->polyTable[poly].surfIndex = surf;

            i += GET_OFFSET-j;
        }
        break;

    default:
        SKIP_INT8(chunkSize-4);
        break;
    }
}