/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * lwoparsetex.c - LWO Object Texture Parser                                  *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "texture/tex.h"
#include "system/file.h"
#include "lightwave/lwo/lwo.h"
#include "lightwave/lwo/lwoparse.h"
#include "lightwave/lwo/lwoparsetools.h"
#include "lightwave/lwo/lwoparsetex.h"
#include "platform/os/window.h"

/*---------------------------------------------------------------------------- TEXTURE */
RESULT
LwoParseTex(void)
{
    Window *window = WindowGet();    
	
	INT32 tex = 0;
    INT32 i = 0;
    INT32 j = 0;

    tex = LwoGetUINT32()-1;

    i = 4;

    while (i<chunkSize)
    {
        subChunkID = LwoGetUINT32();
        subChunkSize = LwoGetUINT16();

        i += 6;

        if ( window->isFullScreen )
		{
			if (subChunkID==CHUNK('S','T','I','L'))
			{
				strcpy(lwoCurr->texTable[tex].fileName, (INT8*) lwoPtr);

				j = 0;
				while (lwoCurr->texTable[tex].fileName[j++]!='.')
				{
					if (lwoCurr->texTable[tex].fileName[j]=='/')
					{
						lwoCurr->texTable[tex].fileName[j] = '\\';
					}
				}

				if (lwoCurr->texTable[tex].fileName[1]=='\\')
				{
					INT8 fileNameAddDrive[STR_DEFAULT_SIZE];

					fileNameAddDrive[0] = lwoCurr->texTable[tex].fileName[0];
					fileNameAddDrive[1] = lwoCurr->texTable[tex].fileName[1];
					fileNameAddDrive[2] = '\\';
					fileNameAddDrive[3] = 0;
					strcat(fileNameAddDrive, &lwoCurr->texTable[tex].fileName[2]);
					strcpy(lwoCurr->texTable[tex].fileName, fileNameAddDrive);
				}

				if (TexAdd(&lwoCurr->texTable[tex])!=OK)
				{
					return ERR_LWO_TEXTURE;
				}
			}
		}
              
        SKIP_INT8(subChunkSize);

        i += subChunkSize;
    }

    return OK;
}
