/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * lwoparsetools.h - LWO Object Tools Parser                                  *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _LWO_PARSE_TOOLS_
#define _LWO_PARSE_TOOLS_

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
void LwoOrderChunks(UINT32 firstChunkID, UINT32 secondChunkID);
UINT8 LwoGetUINT8(void);
UINT16 LwoGetUINT16(void);
UINT32 LwoGetUINT32(void);
UINT32 LwoGetVX(void);
RESULT LwoParseGetPolyTexCount(void);

/*---------------------------------------------------------------------------- PARSE MACROS */
#define CHUNK(a, b, c, d)                               \
(                                                       \
    (UINT32) ((a<<24)+(b<<16)+(c<<8)+d)                 \
)

#define SKIP_INT8(i)                                    \
(                                                       \
    lwoPtr += i                                         \
)

#define BACK_INT8(i)                                    \
(                                                       \
    lwoPtr -= i                                         \
)

#define SET_OFFSET(i)                                   \
(                                                       \
    lwoPtr = (UINT8 *) &lwoFile->buffer[i]              \
)

#define GET_OFFSET                                      \
(                                                       \
    (INT32) (lwoPtr-(UINT8 *) lwoFile->buffer)          \
)

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _LWO_PARSE_TOOLS_ */