/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * lwsinterp.h - LWS Scene Interpoler                                         *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Base author  : Ernie Wright 16 Nov 00 (www.newtek.com)                     *
 * Update author: Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _LWS_INTERP_
#define _LWS_INTERP_

/*---------------------------------------------------------------------------- DEFINES */
#define SHAPE_TCB       0
#define SHAPE_HERM      1
#define SHAPE_BEZI      2
#define SHAPE_LINE      3
#define SHAPE_STEP      4
#define SHAPE_BEZ2      5

/*---------------------------------------------------------------------------- STRUCT */
typedef struct Key
{
    FLOAT32 value;
    FLOAT32 time;
    INT32 shape;
    FLOAT32 tension;
    FLOAT32 continuity;
    FLOAT32 bias;
    FLOAT32 param[4];

    struct Key *next;
    struct Key *prev;    
} Key;

typedef struct Env
{
    Key *key;
    INT32 nkeys;
    INT32 behavior[2];
} Env;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
FLOAT32 EnvEval(Env *env, FLOAT32 time);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _LWS_INTERP_ */

