/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * playlist.h - PlayList                                                      *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _PLAY_LIST_
#define _PLAY_LIST_

/*---------------------------------------------------------------------------- STRUCT */
typedef struct PlayList
{
    INT8 *fileName[STR_DEFAULT_SIZE];

    Lws *lws;

    BOOL isValid;
} PlayList;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
RESULT PlayListAdd(const INT8 *fileName);
RESULT PlayListRemove(const INT8 *fileName);
RESULT PlayListRemoveAll(void);
RESULT PlayListSet(const INT32 i);
RESULT PlayListNext(INT32 *i);

INT32 PlayListGetCount(void);
PlayList *PlayListGet(void);

RESULT PlayListAddArchive(void);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _PLAY_LIST_ */