/******************************************************************************
 * fileio.h - File I/O Accessors                                              *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _FILE_IO_
#define _FILE_IO_

/*---------------------------------------------------------------------------- ENUMS */
typedef enum
{
	FILE_IO_READ_ONLY       = 0,
	FILE_IO_WRITE_ONLY      = 1
} FileIOMode;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
INT32 FileIOInit();
INT32 FileIOOpen(INT8 *fileName, FileIOMode mode);
INT32 FileIOClose(INT32 handle);
INT32 FileIORead(INT32 handle, void *dst, UINT32 size);
INT32 FileIOWrite(INT32 handle, void *src, UINT32 size);
INT32 FileIOGetSize(INT32 handle);
INT8* FileIOGetCurrentDirectory(void);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _FILE_IO_ */