/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * file.c - File I/O Accessors                                                *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/fileio.h"

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static INT8 currentDirectory[STR_DEFAULT_SIZE] = {""};

/*---------------------------------------------------------------------------- INIT */
INT32
FileIOInit()
{
	fileio_init();
    
    return 0;
}

/*---------------------------------------------------------------------------- OPEN */
INT32 
FileIOOpen(INT8 *fileName, FileIOMode mode)
{
	INT32 handle = 0;

    switch(mode)
	{
	case FILE_IO_READ_ONLY:
		handle = fio_open(fileName, O_RDONLY);
		break;

	case FILE_IO_WRITE_ONLY:
		handle = fio_open(fileName, O_CREAT|O_WRONLY);
		break;
	}

    return (INT32) handle;
}

/*---------------------------------------------------------------------------- CLOSE */
INT32 
FileIOClose(INT32 handle)
{
	return fio_close(handle);
}

/*---------------------------------------------------------------------------- READ */
INT32 
FileIORead(INT32 handle, void *dst, UINT32 size)
{
	return fio_read(handle, dst, size);
}

/*---------------------------------------------------------------------------- WRITE */
INT32 
FileIOWrite(INT32 handle, void *src, UINT32 size)
{
	return fio_write(handle, src, size);
}

/*---------------------------------------------------------------------------- GET SIZE */
INT32 
FileIOGetSize(INT32 handle)
{
	INT32 size = 0;
    INT32 pos = 0;

    pos = fio_lseek(handle, pos, SEEK_CUR);
    
    size = fio_lseek(handle, 0, SEEK_END);

    fio_lseek(handle, pos, SEEK_SET);
    
    return size;
}

/*---------------------------------------------------------------------------- GET CURRENT DIRECTORY */
INT8* 
FileIOGetCurrentDirectory(void)
{
    strcpy(currentDirectory, "");
    
    return currentDirectory;
}