
// jfyeNG - a Newtek LightWave scene player
// Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// ******************************************************************************
// * ps2_asm.s - ASM Native Code                                                *
// ******************************************************************************
// * Project      : jfyeNG                                                      *
// * Author       : Arnaud Storq (norecess@planet-d.net)                        *
// * Based on work of Tony Saveski (t_saveski@yahoo.com)                        *
// ******************************************************************************

.set noreorder

.text
.globl dma_reset
.globl gs_set_imr
.globl gs_set_crtc
.globl ps2_flush_cache

// ---------------------------------------------------------------------------- GS SET IMR
.align 7
.ent gs_set_imr
gs_set_imr:
	                li		$4,0x0000FF00
	                ld		$2,0x12001000
	                dsrl	$2,16
	                andi	$2,0xFF
	                li		$3,0x71
	                nop
	                syscall
	                nop

	                daddu	$2,$0,$0
	                jr		$31
	                nop
.end gs_set_imr

// ---------------------------------------------------------------------------- GS SET CRTC
.align 7
.ent gs_set_crtc
gs_set_crtc:
	                li		$3,0x02
	                syscall
	                nop

	                daddu	$2,$0,$0
	                jr		$31
	nop
.end gs_set_crtc

// ---------------------------------------------------------------------------- DMA RESET
.align 7
.ent dma_reset
dma_reset:
	                li	$2,0x1000A000
	                nop
	                sw	$0,0x80($2)
	                sw	$0,0($2)
	                sw	$0,0x30($2)
	                sw	$0,0x10($2)
	                sw	$0,0x50($2)
	                sw	$0,0x40($2)
	                li	$2,0xFF1F
	                sw	$2,0x1000E010
	                lw	$2,0x1000E010
	                li	$3,0xFF1F
	                and	$2,$3
	                sw	$2,0x1000E010
	                sw	$0,0x1000E000
	                sw	$0,0x1000E020
	                sw	$0,0x1000E030
	                sw	$0,0x1000E050
	                sw	$0,0x1000E040
	                li	$3,1
	                lw	$2,0x1000E000
	                ori	$3,$2,1
	                nop
	                sw	$3,0x1000E000
	                nop

	                daddu	$2, $0, $0
	                jr		$31
	                nop
.end dma_reset

// ---------------------------------------------------------------------------- VU0 RESET
.data
.set noat
.set noreorder
.text
.globl vuReset
.ent vuReset
vuReset:
                    cfc2.ni $3, $28
                    li $2, 0xFFFFFF00
                    and $2, $3
                    ori $2, 2
                    ctc2.ni $3, $28
                    sync.p
                    jr $31
                    nop
.end vuReset

// ---------------------------------------------------------------------------- PS2 FLUSH CACHE
.align 7
.ent ps2_flush_cache
ps2_flush_cache:
	                li	$3,100
	                syscall
	                jr	$31
	                nop
.end ps2_flush_cache