/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * ps2draw.h - PS2 Draw Manager                                               *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 * Based on work of Tony Saveski (t_saveski@yahoo.com)                        *
 ******************************************************************************/
#ifndef _PS2_DRAW_
#define _PS2_DRAW_

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
void PS2DrawSetColor(UINT8 r, UINT8 g, UINT8 b);
void PS2DrawEnableZBuffer(BOOL enable);
void PS2DrawClear(INT32 y);
void PS2DrawSetPixel(INT16 x, INT16 y);
void PS2DrawFillRect(INT16 x1, INT16 y1, INT16 x2, INT16 y2);
RESULT PS2SetFont(Font *font);
void PS2DrawChar(INT16 x, INT16 y, INT16 u, INT16 v);

void PS2DrawSetZScale(FLOAT32 scale);
void PS2DrawTriangleBuffer(Vertex *triBuffer, INT32 count, UINT8 r, UINT8 g, UINT8 b);
void PS2DrawTriangleBufferAdd(Vertex *triBuffer, INT32 count, UINT8 r, UINT8 g, UINT8 b);
void PS2DrawTriangleBufferWithTex(Vertex *triBuffer, INT32 count, FLOAT32 w, FLOAT32 h, UINT32 *data);
void PS2DrawTriangleBufferWithTexAdd(Vertex *triBuffer, INT32 count, FLOAT32 w, FLOAT32 h, UINT32 *data);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _PS2_DRAW_ */


