/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * ps2drawtex.c - PS2 Draw Texture Manager                                    *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 * Based on work of Tony Saveski (t_saveski@yahoo.com)                        *
 ******************************************************************************/
#include "platform/os/ps2/ps2.h"
#include "platform/os/font.h"
#include "platform/software/soft.h"
#include "platform/software/softdraw.h"
#include "platform/os/ps2/ps2draw.h"
#include "platform/os/ps2/ps2screen.h"

/*---------------------------------------------------------------------------- EXTERN VARIABLES */
DECLARE_EXTERN_GS_PACKET(packet, DMA_BUFFER_SIZE);

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define TEXTURE_MAX_TRANSFER	16384

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static UINT32 currentTexture = 0;
static VideoMode *videoMode = NULL;

/*---------------------------------------------------------------------------- TEXTURE WIDTH/HEIGHT */
UINT16
PS2DrawTexGetWH(UINT16 n)
{
    UINT16 l = 0;

	n--;

	while (n>0)
    {
        n >>= 1;
        l++;
    }

	return l;
}

/*---------------------------------------------------------------------------- TEXTURE UPLOAD */
void 
PS2DrawTexUpload(UINT16 w, UINT16 h, UINT32 data_adr)
{
    UINT32 i = 0;
    UINT32 frac = 0;
    UINT32 current = 0;
    UINT32 qtotal = 0;

	if (currentTexture==data_adr)
    {
		return;
    }

    videoMode = PS2ScreenGetVideoMode();
    
    currentTexture = data_adr;
    
    BEGIN_GS_PACKET(packet);

	GIF_TAG_AD(packet, 4, 1, 0, 0, 0);

	GIF_DATA_AD(packet, BITBLTBUF, GS_BITBLTBUF(0, 0, 0, PS2ScreenGetVideoRAM()->texBuffer/256, videoMode->width/64, PSMCT16));

	GIF_DATA_AD(packet, TRXPOS, GS_TRXPOS(0, 0, 0, 0, 0));
	GIF_DATA_AD(packet, TRXREG, GS_TRXREG(w, h));
	GIF_DATA_AD(packet, TRXDIR, GS_TRXDIR(XDIR_EE_GS));

	SEND_GS_PACKET(packet);

	qtotal = w*h/4/2;
	current = qtotal%TEXTURE_MAX_TRANSFER;
	frac = 1;

	if (!current)
	{
		current = TEXTURE_MAX_TRANSFER;

		frac = 0;
	}

	for (i=0; i<(qtotal/TEXTURE_MAX_TRANSFER)+frac; i++)
	{
		BEGIN_GS_PACKET(packet);
		GIF_TAG_IMG(packet, current);
		SEND_GS_PACKET(packet);

	    GIF_SET_QWC(((volatile UINT32 *) GIF_QWC), current);
	    GIF_SET_MADR(((volatile UINT32 *) GIF_MADR), data_adr, 0);
        GIF_SET_CHCR(((volatile UINT32 *) GIF_CHCR), 1, 0, 0, 0, 0, 1, 0);
	    DMA_WAIT(((volatile UINT32 *) GIF_CHCR))

		data_adr += current*16;
		current = TEXTURE_MAX_TRANSFER;
	}

	BEGIN_GS_PACKET(packet);
	GIF_TAG_AD(packet, 1, 1, 0, 0, 0);
	GIF_DATA_AD(packet, TEXFLUSH, 0x42);
	SEND_GS_PACKET(packet);
}