/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * ps2matrix.c - PS2 VU Matrix Manager                                        *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/ps2/ps2.h"
#include "platform/os/ps2/ps2matrix.h"

/*---------------------------------------------------------------------------- VECTOR / MATRIX MULT */
void 
PS2MatrixVectMultTable(T_VEC *dst, T_MATRIX *mat, T_VEC *src, INT32 count)
{
	asm __volatile__("
vu0_apply_matrix.loop:
		lqc2 vf4,0x0(%1)
		lqc2 vf5,0x10(%1)
		lqc2 vf6,0x20(%1)
		lqc2 vf7,0x30(%1)
		lqc2 vf8,0x0(%2)
		vmulax.xyzw  ACCxyzw, vf4xyzw,vf8x
		vmadday.xyzw ACCxyzw,    vf5xyzw,vf8y
		vmaddaz.xyzw ACCxyzw,    vf6xyzw,vf8z
		vmaddw.xyzw  vf9xyzw, vf7xyzw,vf0w
		sqc2 vf9, 0x0(%0)
		addiu %3, -1
		addiu %0, 0x30
		addiu %2, 0x10
		bnez %3, vu0_apply_matrix.loop
		nop
		"
		:
		: "r"(dst) , "r"(mat), "r"(src), "r"(count)
		: "memory" );
}

/*---------------------------------------------------------------------------- VECTOR / MATRIX MULT */
void 
PS2MatrixVectMultWithWTable(T_VEC *dst, T_MATRIX *mat, T_VEC *src, INT32 count)
{
	asm __volatile__("
vu0_apply_matrix_w.loop:
		lqc2 vf4,0x0(%1)
		lqc2 vf5,0x10(%1)
		lqc2 vf6,0x20(%1)
		lqc2 vf7,0x30(%1)
		lqc2 vf8,0x0(%2)
		vmulax.xyzw  ACCxyzw, vf4xyzw,vf8x
		vmadday.xyzw ACCxyzw,    vf5xyzw,vf8y
		vmaddaz.xyzw ACCxyzw,    vf6xyzw,vf8z
		vmaddw.xyzw  vf9xyzw, vf7xyzw,vf0w
		sqc2 vf9, 0x0(%0)
		addiu %3, -1
		addiu %0, 0x30
		addiu %2, 0x30
		bnez %3, vu0_apply_matrix_w.loop
		nop
		"
		:
		: "r"(dst) , "r"(mat), "r"(src), "r"(count)
		: "memory" );
}

/*---------------------------------------------------------------------------- MATRIX MULT */
void
PS2MatrixMult(T_MATRIX *dst, T_MATRIX *src1, T_MATRIX *src2)
{
	asm __volatile__("
		lqc2 vf4,0x0(%2)
		lqc2 vf5,0x10(%2)
		lqc2 vf6,0x20(%2)
		lqc2 vf7,0x30(%2)
		li $7,4
1:
		lqc2 vf8,0x0(%1)		
		vmulax.xyzw ACC, vf4,vf8
		vmadday.xyzw ACC, vf5,vf8
		vmaddaz.xyzw ACC, vf6,vf8
		vmaddw.xyzw	vf9,vf7,vf8	
		sqc2 vf9,0x0(%0)
		addi $7,-1
		addi %1,0x10
		addi %0,0x10
		bne $0,$7,1b
		"
		:
		: "r"(dst), "r"(src1), "r"(src2)
		: "$7");
}