/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * ps2screen.h - PS2 Screen Manager                                           *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 * Based on work of Tony Saveski (t_saveski@yahoo.com)                        *
 ******************************************************************************/
#ifndef _PS2_SCREEN_
#define _PS2_SCREEN_

/*---------------------------------------------------------------------------- STRUCT */
typedef struct VideoMode
{
	UINT16 width;
	UINT16 height;
	UINT16 depth;
	UINT16 hmag;

    UINT16 originX;
    UINT16 originY;
} VideoMode;

typedef struct VideoRAM
{
    INT32 offset;

    UINT32 zBufferAddr;
    
    BOOL bufferIsFront;
    UINT32 frontBuffer;
    UINT32 backBuffer;
    
    UINT32 texBuffer;
} VideoRAM;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
RESULT PS2ScreenInit(void);
void PS2ScreenWaitVBL(void);
void PS2ScreenRefresh(void);

VideoMode* PS2ScreenGetVideoMode(void);
VideoRAM* PS2ScreenGetVideoRAM(void);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _PS2_SCREEN_ */