
#include <windows.h>
#include <string>

#include <config.h>
#include "cpcConvert.h"
#include "texture/tex.h"

unsigned int wroteFrame = 0;

unsigned char frame[ 40 * 25 * 20 * 2 ];

unsigned short lastWord;

unsigned char isOverscan = false;

static bool isBitmap = true;
int maxBitmapFrames;

unsigned char *images[ 100 ];

extern "C" void initCpcFile( )
{
	wroteFrame = 0;

	remove( "c:\\output\\_SCENE.BIN" );

	for ( unsigned int iFrame = 0; iFrame < 500; iFrame++ )
	{
		char convert[ 16 ];
		itoa( iFrame, convert, 10 );
		std::string filename;
		filename = "c:\\output\\FRAME_";
		filename += convert;
		filename += ".BIN";

		remove( filename.c_str() );

		filename += ".PCK";

		remove( filename.c_str() );
	}

	if ( isBitmap )
	{
		isBitmap = true;
		maxBitmapFrames = 20; // dancing
		maxBitmapFrames = 1; // credit
		maxBitmapFrames = 29; // dancing 2

		for ( unsigned int iFrame = 1; iFrame <= maxBitmapFrames; iFrame++ )
		{
			char convert[ 16 ];
			itoa( iFrame, convert, 10 );
			std::string filename;
			//filename = "C:\\dancing\\dancing15_frame_00";
			filename = "C:\\dancing\\t139186306_66452_frame_00";
			if ( iFrame <= 9 )
			{
				filename += "0";
			}
			filename += convert;
			filename += ".RAW";

			FILE *handle = fopen( filename.c_str(), "rb" );

			fseek( handle, 0, SEEK_END );
			int inSize = ftell( handle );
			fseek( handle, 0, SEEK_SET );

			images[ iFrame - 1 ] = new unsigned char[ inSize + 1 ];
			memset( images[ iFrame - 1 ], 0, inSize + 1 );

			fread( images[ iFrame - 1 ], 1, inSize, handle );

			fclose( handle );
		}
	}
}

extern "C" void writeCpcFile( )
{
	if ( wroteFrame == 0 )
	{
		return;
	}

	FILE *fileWriteHandle = fopen( "c:\\output\\_SCENE.BIN", "wb" );

	fwrite( &isOverscan, 1, 1, fileWriteHandle );

	unsigned char nbFrames = wroteFrame / 1; ////
	fwrite( &nbFrames, 1, 1, fileWriteHandle );

	for ( unsigned int iFrame = 0; iFrame < wroteFrame; iFrame+=1 ) ////
	{
		char convert[ 16 ];
		itoa( iFrame, convert, 10 );
		std::string filename;
		filename = "FRAME_";
		filename += convert;
		filename += ".BIN.PCK";

		FILE *fileReadHandle = fopen( filename.c_str(), "rb" );
		if ( fileReadHandle )
		{
			fseek( fileReadHandle, 0, SEEK_END );
			int inSize = ftell( fileReadHandle );
			fseek( fileReadHandle, 0, SEEK_SET );

			unsigned char *ptr = new unsigned char[ inSize + 1 ];
			memset( ptr, 0, inSize + 1 );

			fread( ptr, 1, inSize, fileReadHandle );

			unsigned short chunkSize = inSize;
			fwrite( &chunkSize, sizeof(unsigned short), 1, fileWriteHandle );

			fwrite( ptr, 1, chunkSize, fileWriteHandle );

			fclose( fileReadHandle );

			delete [] ptr;
		}
	}

	fclose( fileWriteHandle );

	exit( 0 );
}

unsigned char getPixel( unsigned int x, unsigned int y, unsigned int *buffer, unsigned int bufferPitch )
{
	unsigned int pixel32 = buffer [ ( y * bufferPitch ) + x ];

	unsigned int r = pixel32 & 255;
	unsigned int g = ( pixel32 >> 8 ) & 255;
	unsigned int b = ( pixel32 >> 16 ) & 255;

	unsigned int pixel = ( r + g + b ) / 3;
	
	 pixel >>= 4;

	// guard
//	pixel >>= 3;

	if ( isBitmap )
	{		
		unsigned char *ptr = images[ wroteFrame ];

		pixel = ptr[ ( y * 96) + x ]; // * 3
	}

	// phat 2
	/*if ( pixel < 9 )
	{
		//if ( pixel != 2 )
		{
			pixel = 0;
		}
	}
	else
	{
		pixel = 15;
	}	*/

	// torus trip
	/*if ( pixel < 10 )
	{
		pixel = 0;
	}
	else
	{
		pixel = 15;
	}*/


	// dancing
	/*if ( pixel > 4 )
	{
		pixel = 15;
	}
	else
	{
		pixel = 0;
	}*/
    
	// dancing 2
	if ( pixel > 4 )
	{
		pixel = 15;
	}
	else
	{
		pixel = 0;
	}

    // transit
	/*if ( pixel > 4 )
    {
        pixel = 0;
    }
    else
	{
		pixel = 15;
	}*/

	// credit
	/*if ( pixel == 0x55 )
	{
		pixel = 1;
	}
	else
	if ( pixel == 0xaa )
	{
		pixel = 2;
	}
	else
	if ( pixel == 0xff )
	{
		pixel = 3;
	}
	else
	{
		pixel = 0;
	}*/

	unsigned char v;
	v =		( ( ( pixel      ) & 1 ) << 7 ) + ( ( ( pixel      ) & 1 ) << 6 ) 
		+   ( ( ( pixel >> 2 ) & 1 ) << 5 ) + ( ( ( pixel >> 2 ) & 1 ) << 4 ) 
		+   ( ( ( pixel >> 1 ) & 1 ) << 3 ) + ( ( ( pixel >> 1 ) & 1 ) << 2 ) 
		+   ( ( ( pixel >> 3 ) & 1 ) << 1 ) + ( ( ( pixel >> 3 ) & 1 ) );

	return (unsigned char) v;
}

unsigned int frameSize = 0;

void cpcConvert( unsigned int width, unsigned int height, unsigned int *buffer, unsigned int bufferPitch )
{
	unsigned int x;
	unsigned int y;
	unsigned short word;
	unsigned short pageOffset = 0xF800 - 384;

	if ( isBitmap )
	{
		if ( wroteFrame == maxBitmapFrames )
		{
			writeCpcFile();
			
			return;
		}
	}

	bool firstPixel = true;

	isOverscan = false;
	if ( ( width == CPCRESX_OVERSCAN ) && ( height == CPCRESY_OVERSCAN ) )
	{
		isOverscan = true;
	}		

	frameSize = 0;

	frameSize++;
	frameSize++;
	
	for ( y = height - 1; y != 0; y-- )
	{
		for ( x = width - 2; x != -2; x -= 2 )
		{
			if ( isBitmap )
			{		
				word = getPixel( x, y, buffer, bufferPitch ) << 8;
				word += getPixel( x + 1, y, buffer, bufferPitch );
			}
			else
			{
				word = getPixel( x, y, buffer, bufferPitch ) << 8;
				word += getPixel( x + 1, y, buffer, bufferPitch );
			}

			if ( ( firstPixel ) || ( word != lastWord ) )
			{
				firstPixel = false;
				
				frame[ frameSize++ ] = 0x01; // LD BC, ..
				frame[ frameSize++ ] = word >> 8; // LD BC, ..
				frame[ frameSize++ ] = word & 255; // LD BC, ..
			}

			frame[ frameSize++ ] = 0xC5; // PUSH BC

			lastWord = word;

			pageOffset -= 2;
			if ( pageOffset == 0xF000 )
			{
				frame[ frameSize - 1 ] = 0xF3; // DI
				frame[ frameSize++ ] = 0xC5; // PUSH BC
				
				frame[ frameSize++ ] = 0xE9; // JP (HL)

				frame[ 0 ] = frameSize & 255;
				frame[ 1 ] = frameSize >> 8;

				firstPixel = true;
			}
		}
	}

	frame[ frameSize - 1 ] = 0xF3; // DI
	frame[ frameSize++ ] = 0xC5; // PUSH BC

	frame[ frameSize++ ] = 0xE9; // JP (HL)

	if ( wroteFrame != 255 )
	{
		std::string dir;
		dir += "c:\\output\\";

		SetCurrentDirectory( dir.c_str() );
		
		char convert[ 16 ];
		itoa( wroteFrame, convert, 10 );
		std::string filename;
		filename = "FRAME_";
		filename += convert;
		filename += ".BIN";

		std::string fullPath = dir;
		fullPath += filename;

		FILE *fileHandle = fopen( fullPath.c_str( ), "wb" );
		fwrite( frame, frameSize, 1, fileHandle );
		fclose( fileHandle );

		wroteFrame++;

		std::string packFilename;
		packFilename += "c:\\output\\pack.exe ";
		packFilename += filename;
		WinExec( packFilename.c_str(), SW_NORMAL );

		Sleep( 1500 );
	}
}