/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * window.c - Output Window                                                   *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/renderer/matrix.h"
#include "platform/os/font.h"
#include "platform/os/win32/rsc/resource.h"
#include "platform/os/gui.h"
#include "platform/os/window.h"
#include "system/mem.h"
#include "platform/os/win32/ddraw/switchscreenmode.h"

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static void (*funcInit)(void) = NULL;
static void (*funcDraw)(void) = NULL;
static void (*funcFree)(void) = NULL;
static void (*funcKey)(INT32 key) = NULL;
static Window window;

/*---------------------------------------------------------------------------- SET INIT */
RESULT
WindowSetInit(void (*func)(void))
{
    return DXWindowSetInit(func);
}

/*---------------------------------------------------------------------------- SET DRAW */
RESULT
WindowSetDraw(void (*func)(void))
{
    return DXWindowSetDraw(func);
}

/*---------------------------------------------------------------------------- SET FREE */
RESULT
WindowSetFree(void (*func)(void))
{
    return DXWindowSetFree(func);
}

/*---------------------------------------------------------------------------- SET KEY */
RESULT
WindowSetKey(void (*func)(INT32 param))
{
    return DXWindowSetKey(func);
}

extern int writeCPCOutput;

/*---------------------------------------------------------------------------- SHOW */
RESULT
WindowShow(void)
{
    HWND parent = NULL;
	
	parent = (HWND) UserInterfaceGetID();
	
	EnableWindow(parent, FALSE);

	window.zBuffer = (UINT32 *) MemAlloc(WindowGet()->resX*WindowGet()->resY*sizeof(UINT32));
	window.zBufferPitch = WindowGet()->resX;
	
	if ( WindowGet()->isBilinear != 0 )
	{
		writeCPCOutput = 1;
	}

	DXWindowShow(GetModuleHandle(NULL), parent, (INT8 *) WindowGet()->title, WindowGet()->resX, WindowGet()->resY, 0);

	MemFree(window.zBuffer);
	
	EnableWindow(parent, TRUE);
	SetFocus(parent);

	return OK;
}

/*---------------------------------------------------------------------------- GET */
Window *
WindowGet(void)
{
    window.buffer = DXWindowGetBuffer();
	window.bufferPitch = DXWindowGetBufferPitch();
	
	return &window;
}

/*---------------------------------------------------------------------------- DISPLAY TEXT */
void
WindowDisplayText(INT32 x, INT32 negY, const INT8 *msg, ...)
{
    INT32 charHeight = 0;
	INT8 str[STR_DEFAULT_SIZE];
    va_list argList;
    
    if (msg==NULL)
    {
        return;
    }

    va_start(argList, msg);
    vsprintf(str, msg, argList);
    va_end(argList);

	charHeight = FontGet()->charHeight;

	FontDisplayText(x, window.resY-charHeight*2-charHeight*negY, str);
}