/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <config.h>
/******************************************************************************
 * settings.c - Settings                                                      *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/settings.h"
#include "platform/os/fileio.h"

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define SETTINGS_FILENAME		"jfyeNG.ini"
#define SETTINGS_GUI_SECTION	"GUI"

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static const INT8 keyTable[6][STR_DEFAULT_SIZE] =
{
	"LWPath",
	"ScenePath",
	"AudioPath",
    "Resolution",
    "FullScreen",
	"Bilinear"
};
static INT8 iniFile[STR_DEFAULT_SIZE] = {""};

/*---------------------------------------------------------------------------- BUILD FILENAME */
static
buildFilename(void)
{
	strcpy(iniFile, FileIOGetCurrentDirectory());
	strcat(iniFile, SETTINGS_FILENAME);	
}

/*---------------------------------------------------------------------------- GUI CONFIG */
void
SettingsGetValue(SettingsKey key, INT8 *buffer)
{
	buildFilename();

	GetPrivateProfileString(SETTINGS_GUI_SECTION, keyTable[key], "", buffer, STR_DEFAULT_SIZE, iniFile);
}

void
SettingsSetValue(SettingsKey key, const INT8 *value)
{
	buildFilename();

	SetFileAttributes(iniFile, FILE_ATTRIBUTE_NORMAL);	
    
    WritePrivateProfileString(SETTINGS_GUI_SECTION, keyTable[key], value, iniFile);
}