/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <config.h>
/******************************************************************************
 * splash.c - Splash Screen                                                   *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/win32/rsc/resource.h"
#include "platform/os/splash.h"
#include "platform/os/main.h"

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define SPLASH_WAIT_TIME_IN_MS      200

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static BOOL destroy = FALSE;

/*---------------------------------------------------------------------------- SPLASH CALLBACK */
static BOOL CALLBACK 
DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
    case WM_CLOSE:
        destroy = TRUE;
        break;
    }

    hwndDlg;
    wParam;
    lParam;
    
    return FALSE;
}

/*---------------------------------------------------------------------------- SHOW */
void
SplashShow(UINT32 param)
{
    INT8 text[STR_DEFAULT_SIZE];
	HWND hwnd = NULL;
    HICON icon;
    HINSTANCE instance;
    DWORD baseTick = 0;
    
    instance = GetModuleHandle(NULL);
    
    hwnd = CreateDialog(instance, (LPCTSTR) MAKEINTRESOURCE(IDD_SPLASH), (HWND) param, &DialogProc);
		
	icon = LoadIcon(instance, (LPCTSTR) MAKEINTRESOURCE(IDI_JFYENG));
	SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM) icon);
	SendMessage(hwnd, WM_SETICON, ICON_BIG, (LPARAM) icon);

	wsprintf(text, "jfyeNG %s (c) Arnaud Storq 1998-2003", GetRenderName());		
	SendDlgItemMessage(hwnd, ID_TEXT, WM_SETTEXT, 0, (long)&text);

    ShowWindow(hwnd, SW_SHOWNORMAL);
	UpdateWindow(hwnd);
	
    baseTick = GetTickCount();

    destroy = FALSE;
    
    while (!destroy && (baseTick+SPLASH_WAIT_TIME_IN_MS)>GetTickCount())
    {
    }

    DestroyWindow(hwnd);
}
