/******************************************************************************
 * window.h - Output Window                                                   *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _WINDOW_
#define _WINDOW_

#ifdef WIN32
    #include <windows.h>
    #include <GL/gl.h>
    #include <GL/glu.h>
#endif

/*---------------------------------------------------------------------------- WINDOW */
typedef struct Window
{
    INT8 *title[STR_DEFAULT_SIZE];

    INT32 resX;
    INT32 resY;

    BOOL isFullScreen;
	BOOL isBilinear;

	UINT32 handle;

	INT32 *buffer;
	INT32 bufferPitch;
	UINT32 *zBuffer;
	INT32 zBufferPitch;
} Window;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
#ifndef SKIP_C_FUNCTIONS

RESULT WindowSetInit(void (*func)(void));
RESULT WindowSetDraw(void (*func)(void));
RESULT WindowSetFree(void (*func)(void));
RESULT WindowSetKey(void (*func)(INT32 key));

RESULT WindowShow(void);

Window *WindowGet(void);

void WindowDisplayText(INT32 x, INT32 negY, const INT8 *msg, ...);

#endif

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _WINDOW_ */