/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <config.h>
/******************************************************************************
 * nativetexhard.c - Texture Hardware Manager                                 *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/renderer/texhard.h"

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define	USE_TRILINEAR	1

/*---------------------------------------------------------------------------- TEX HARD INIT */
void
TexHardInit(void)
{
}

/*---------------------------------------------------------------------------- ADD TEXTURE TO HARDWARE*/
RESULT 
TexHardAdd(INT32 *id, void *buffer, INT32 width, INT32 height, INT32 depth)
{
    UINT32 glID = 0;
    
    glGenTextures(1, &glID);

    glBindTexture(GL_TEXTURE_2D, glID);

    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);    
#ifdef USE_TRILINEAR
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
#else
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
#endif
	
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

    gluBuild2DMipmaps(GL_TEXTURE_2D, depth>>3, width, height, GL_RGBA, GL_UNSIGNED_BYTE, buffer);

    *id = glID;

    return OK;
}

/*---------------------------------------------------------------------------- GET POOL OFFSET */
INT32
TexHardGetPoolOffset(INT32 id)
{
    id = 0;
	
	return 0;
}

INT32 TexHardGetPoolOffset(INT32 id);

/*---------------------------------------------------------------------------- DEFRAG POOL */
void 
TexHardPoolDefrag(void)
{
}

/*---------------------------------------------------------------------------- REMOVE TEXTURE FROM HARDWARE */
RESULT 
TexHardDelete(INT32 *id)
{
    glDeleteTextures(1, (UINT32 *) id);

    return OK;
}




















