/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * lwsdrawlight.h - LWS Scene Light Manager                                   *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _LWS_DRAW_LIGHT_
#define _LWS_DRAW_LIGHT_

/*---------------------------------------------------------------------------- ENUM */
typedef enum
{
    LightUndef,
    LightPoint,
    LightSpot,
    LightDistant,
} LightType;

/*---------------------------------------------------------------------------- STRUCT */
typedef struct Light
{
    UINT32 glID;

    INT8 name[STR_DEFAULT_SIZE];

    LightType type;

    BOOL isEnabled;
    
    FLOAT32 colorR;
    FLOAT32 colorG;
    FLOAT32 colorB;

    INT32 *IDBuffer1;
	INT32 *IDBuffer2;

    FLOAT32 rotX;
    FLOAT32 rotY;
    FLOAT32 rotZ;

    FLOAT32 transX;
    FLOAT32 transY;
    FLOAT32 transZ;
    
    FLOAT32 intens;
    Env *envIntens;

    FLOAT32 sizeCoef;
} Light;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
void LightAmbientSet(float r, float g, float b, float intens);
RESULT LightEnable(Light *light);
RESULT LightDisable(Light *light);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _LWS_DRAW_LIGHT_ */