/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * matrix.h - Matrix                                                          *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _MATRIX_
#define _MATRIX_

/*---------------------------------------------------------------------------- GLOBAL DEFINES */
#define MATRIX_MODELVIEW        0x1700
#define MATRIX_PROJECTION       0x1701
#define MATRIX_TEXTURE          0x1702

/*---------------------------------------------------------------------------- JFYENG SPECIFIC */
void MatrixInit(void);

T_MATRIX *MatrixGet(INT32 mode);

void MatrixVectMult(T_VEC *res, T_VEC *in, T_MATRIX *mat);
void MatrixVectMultEnvMap(T_VEC *res, T_VEC *in, T_MATRIX *mat);
void MatrixVectMultWithW(T_VEC *res, T_VEC *in, T_MATRIX *mat);

void MatrixVectMultTable(T_VEC *dst, INT32 dstPad, T_MATRIX *mat, T_VEC *src, INT32 srcPad, INT32 count);
void MatrixVectMultWithWTable(T_VEC *dst, INT32 dstPad, T_MATRIX *mat, T_VEC *src, INT32 srcPad, INT32 count);

void MatrixDump(T_MATRIX *mat);

/*---------------------------------------------------------------------------- OPENGL WRAPPER */
void MatrixLoadIdentity(void);
void MatrixRotate(FLOAT32 angle, FLOAT32 x, FLOAT32 y, FLOAT32 z);
void MatrixTranslate(FLOAT32 x, FLOAT32 y, FLOAT32 z);
void MatrixScale(FLOAT32 x, FLOAT32 y, FLOAT32 z);

void MatrixFrustum(FLOAT32 left, FLOAT32 right, FLOAT32 bottom, FLOAT32 top, FLOAT32 zNear, FLOAT32 zFar);
void MatrixOrtho(FLOAT32 left, FLOAT32 right, FLOAT32 bottom, FLOAT32 top, FLOAT32 zNear, FLOAT32 zFar);

void MatrixPush(void);
void MatrixPop(void);

void MatrixMult(T_MATRIX *m);

void MatrixMode(INT32 mode);
void MatrixLoad(T_MATRIX *m);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _MATRIX_ */