/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * texhard.c - Texture Hardware Manager                                       *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/renderer/texhard.h"
#include "platform/os/ps2/ps2.h"

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define TEX_HARD_MAX_COUNT     256

/*---------------------------------------------------------------------------- LOCAL STRUCT */
typedef struct TexHard
{
    void *buffer;
	INT32 size;

    INT32 offset;

    INT32 width;
    INT32 height;
	INT32 depth;
} TexHard;

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static INT32 offset = 0;
static INT32 texHardCount = 0;
static TexHard texHard[TEX_HARD_MAX_COUNT];

/*---------------------------------------------------------------------------- TEX HARD INIT */
void
TexHardInit(void)
{
}

/*---------------------------------------------------------------------------- ADD TEXTURE TO HARDWARE */
RESULT 
TexHardAdd(INT32 *id, void *buffer, INT32 width, INT32 height, INT32 depth)
{
    if (id==NULL || buffer==NULL)
    {
        return ERR_INVALID_PTR;
    }

    *id = texHardCount;

    texHard[*id].buffer = buffer;
    texHard[*id].width = width;
    texHard[*id].height = height;
    texHard[*id].offset = offset;
	texHard[*id].depth = depth;

    offset += width*height*(depth>>3);
        
    texHardCount++;

    return OK;
}

/*---------------------------------------------------------------------------- GET POOL OFFSET */
INT32
TexHardGetPoolOffset(INT32 id)
{
    if (id<0 || id>=texHardCount)
    {
        return -1;
    }

    return texHard[id].offset;
}

/*---------------------------------------------------------------------------- DEFRAG POOL */
void
TexHardPoolDefrag(void)
{    
}

/*---------------------------------------------------------------------------- REMOVE TEXTURE FROM HARDWARE */
RESULT 
TexHardDelete(INT32 *id)
{
    if (id==NULL)
    {
        return ERR_INVALID_PTR;
    }
    
    return OK;
}
