/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * softdraw.h - Software Draw                                                 *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _SOFT_DRAW_
#define _SOFT_DRAW_

/*---------------------------------------------------------------------------- DEFINES */
#define BITS_X_SHIFT	16
#define BITS_Z_SHIFT	16
#define BITS_STQ_SHIFT	24

#define COEF_X_FLOAT32		(1.0f*(1<<BITS_X_SHIFT))
#define COEF_Z_FLOAT32		(1.0f*(1<<BITS_Z_SHIFT))
#define COEF_STQ_FLOAT32	(1.0f*(1<<BITS_STQ_SHIFT))

/*---------------------------------------------------------------------------- STRUCT */
typedef struct SoftViewport
{
    INT32 *buffer;
	
	INT16 x1;
	INT16 y1;
	INT16 x2;
	INT16 y2;
} SoftViewport;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
RESULT SoftDrawSetViewport(SoftViewport *viewport);
SoftViewport* SoftDrawGetViewport(void);

void SoftDrawClearViewport(UINT8 r, UINT8 g, UINT8 b, UINT32 a);

void SoftDrawTriangleBuffer(Vertex *triBuffer, INT32 count, UINT8 r, UINT8 g, UINT8 b);
void SoftDrawTriangleBufferAdd(Vertex *triBuffer, INT32 count, UINT8 r, UINT8 g, UINT8 b);

void SoftDrawTriangleBufferWithTex(Vertex *triBuffer, INT32 count, FLOAT32 w, FLOAT32 h, UINT32 *data);
void SoftDrawTriangleBufferWithTexAdd(Vertex *triBuffer, INT32 count, FLOAT32 w, FLOAT32 h, UINT32 *data);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _SOFT_DRAW_ */