/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#define NO_MATH_H
#include <config.h>
/******************************************************************************
 * softdrawtritex.c - Software Draw Tex Triangle                              *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/window.h"
#include "platform/software/soft.h"
#include "platform/software/softdraw.h"
#include "platform/software/softdrawbilinear.h"
#include "platform/software/softdrawtritex.h"

/*---------------------------------------------------------------------------- EXTERN VARIABLES */
extern FLOAT32 x1;
extern FLOAT32 y1;
extern FLOAT32 z1;
extern FLOAT32 s1;
extern FLOAT32 t1;
extern FLOAT32 q1;
extern FLOAT32 x2;
extern FLOAT32 y2;
extern FLOAT32 z2;
extern FLOAT32 s2;
extern FLOAT32 t2;
extern FLOAT32 q2;
extern FLOAT32 x3;
extern FLOAT32 y3;
extern FLOAT32 z3;
extern FLOAT32 s3;
extern FLOAT32 t3;
extern FLOAT32 q3;

extern INT32 color;
extern INT32 bufferPitch;
extern INT32 zBufferPitch;
extern INT32 *buffer;
extern UINT32 *zBuffer;
extern UINT32 *texBuffer;
extern INT32 texPitch;
extern INT32 texWidth;
extern INT32 texHeight;

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static FLOAT32 tmp = 0.0f;
static FLOAT32 leftX = 0.0f;
static FLOAT32 rightX = 0.0f;
static FLOAT32 leftDeltaX = 0.0f;
static FLOAT32 rightDeltaX = 0.0f;
static FLOAT32 secondDeltaX = 0.0f;
static FLOAT32 leftZ = 0.0f;
static FLOAT32 rightZ = 0.0f;
static FLOAT32 leftDeltaZ = 0.0f;
static FLOAT32 rightDeltaZ = 0.0f;
static FLOAT32 secondDeltaZ = 0.0f;
static FLOAT32 leftS = 0.0f;
static FLOAT32 rightS = 0.0f;
static FLOAT32 leftDeltaS = 0.0f;
static FLOAT32 rightDeltaS = 0.0f;
static FLOAT32 secondDeltaS = 0.0f;
static FLOAT32 leftT = 0.0f;
static FLOAT32 rightT = 0.0f;
static FLOAT32 leftDeltaT = 0.0f;
static FLOAT32 rightDeltaT = 0.0f;
static FLOAT32 secondDeltaT = 0.0f;
static FLOAT32 leftQ = 0.0f;
static FLOAT32 rightQ = 0.0f;
static FLOAT32 leftDeltaQ = 0.0f;
static FLOAT32 rightDeltaQ = 0.0f;
static FLOAT32 secondDeltaQ = 0.0f;
static FLOAT32 start = 0.0f;
static FLOAT32 end = 0.0f;
static INT32 x = 0;
static INT32 y = 0;
static UINT32 z = 0;
static FLOAT32 s = 0;
static FLOAT32 t = 0;
static FLOAT32 q = 0;
static INT32 u = 0;
static INT32 v = 0;
static INT32 bufferOffset = 0;
static INT32 zBufferOffset = 0;
static INT32 zy = 0;
static INT32 xSize = 0;
static INT32 ySize = 0;
static INT32 leftXFixed = 0;
static INT32 rightXFixed = 0;
static INT32 leftDeltaXFixed = 0;
static INT32 rightDeltaXFixed = 0;
static INT32 leftZFixed = 0;
static INT32 rightZFixed = 0;
static INT32 leftDeltaZFixed = 0;
static INT32 rightDeltaZFixed = 0;
static INT32 deltaZFixed = 0;
static INT32 w = 0;
static INT32 h = 0;
static FLOAT32 deltaS = 0.0f;
static FLOAT32 deltaT = 0.0f;
static FLOAT32 deltaQ = 0.0f;
static FLOAT32 firstY = 0.0f;
static FLOAT32 secondY = 0.0f;
static INT32 *bufferLine;
static UINT32 *zBufferLine;
static BOOL ok = FALSE;

/*---------------------------------------------------------------------------- DRAW FLAT TRIANGLE */
void
SoftDrawTriTex(void)
{
	if (y2<y1)
	{
		tmp = y1;
		y1 = y2;
		y2 = tmp;

		tmp = x1;
		x1 = x2;
		x2 = tmp;

		tmp = z1;
		z1 = z2;
		z2 = tmp;

		tmp = s1;
		s1 = s2;
		s2 = tmp;

		tmp = t1;
		t1 = t2;
		t2 = tmp;

		tmp = q1;
		q1 = q2;
		q2 = tmp;
	}

	if (y3<y2)
	{
		tmp = y2;
		y2 = y3;
		y3 = tmp;

		tmp = x2;
		x2 = x3;
		x3 = tmp;

		tmp = z2;
		z2 = z3;
		z3 = tmp;

		tmp = s2;
		s2 = s3;
		s3 = tmp;

		tmp = t2;
		t2 = t3;
		t3 = tmp;

		tmp = q2;
		q2 = q3;
		q3 = tmp;
	}

	if (y2<y1)
	{
		tmp = y1;
		y1 = y2;
		y2 = tmp;

		tmp = x1;
		x1 = x2;
		x2 = tmp;

		tmp = z1;
		z1 = z2;
		z2 = tmp;

		tmp = s1;
		s1 = s2;
		s2 = tmp;

		tmp = t1;
		t1 = t2;
		t2 = tmp;

		tmp = q1;
		q1 = q2;
		q2 = tmp;
	}

	if (y1==y2)
	{
		if (y3==y2)
		{
			y3 += 0.0000001f;
		}

		leftX = x1;
		leftZ = z1;
		leftS = s1;
		leftT = t1;
		leftQ = q1;

		rightX = x2;
		rightZ = z2;
		rightS = s2;
		rightT = t2;
		rightQ = q2;

		leftDeltaX = (x3-x1)/(y3-y1);
		leftDeltaZ = (z3-z1)/(y3-y1);
		leftDeltaS = (s3-s1)/(y3-y1);
		leftDeltaT = (t3-t1)/(y3-y1);
		leftDeltaQ = (q3-q1)/(y3-y1);

		rightDeltaX = (x3-x2)/(y3-y1);
		rightDeltaZ = (z3-z2)/(y3-y1);
		rightDeltaS = (s3-s2)/(y3-y1);
		rightDeltaT = (t3-t2)/(y3-y1);
		rightDeltaQ = (q3-q2)/(y3-y1);

		end = y3;
		
		if (leftDeltaX>rightDeltaX)
		{
			tmp = leftX;
			leftX = rightX;
			rightX = tmp;

			tmp = leftZ;
			leftZ = rightZ;
			rightZ = tmp;

			tmp = leftS;
			leftS = rightS;
			rightS = tmp;

			tmp = leftT;
			leftT = rightT;
			rightT = tmp;

			tmp = leftQ;
			leftQ = rightQ;
			rightQ = tmp;
		}
	}	
	else
	{
		if (y3==y1)
		{
			y3 += 0.0000001f;
		}

		leftX = x1;
		leftZ = z1;
		leftS = s1;
		leftT = t1;
		leftQ = q1;

		rightX = x1;
		rightZ = z1;
		rightS = s1;
		rightT = t1;
		rightQ = q1;

		leftDeltaX = (x2-x1)/(y2-y1);
		leftDeltaZ = (z2-z1)/(y2-y1);
		leftDeltaS = (s2-s1)/(y2-y1);
		leftDeltaT = (t2-t1)/(y2-y1);
		leftDeltaQ = (q2-q1)/(y2-y1);

		rightDeltaX = (x3-x1)/(y3-y1);
		rightDeltaZ = (z3-z1)/(y3-y1);
		rightDeltaS = (s3-s1)/(y3-y1);
		rightDeltaT = (t3-t1)/(y3-y1);
		rightDeltaQ = (q3-q1)/(y3-y1);

		end = y2;
	}
		
	if (leftDeltaX>rightDeltaX)
	{
		tmp = leftDeltaX;
		leftDeltaX = rightDeltaX;
		rightDeltaX = tmp;

		tmp = leftDeltaZ;
		leftDeltaZ = rightDeltaZ;
		rightDeltaZ = tmp;

		tmp = leftDeltaS;
		leftDeltaS = rightDeltaS;
		rightDeltaS = tmp;

		tmp = leftDeltaT;
		leftDeltaT = rightDeltaT;
		rightDeltaT = tmp;

		tmp = leftDeltaQ;
		leftDeltaQ = rightDeltaQ;
		rightDeltaQ = tmp;
	}
	
	if (leftX>rightX)
	{			
		tmp = rightX;
		rightX = leftX;
		leftX = tmp;

		tmp = leftDeltaX;
		leftDeltaX = rightDeltaX;
		rightDeltaX = tmp;

		tmp = rightZ;
		rightZ = leftZ;
		leftZ = tmp;

		tmp = leftDeltaZ;
		leftDeltaZ = rightDeltaZ;
		rightDeltaZ = tmp;

		tmp = rightS;
		rightS = leftS;
		leftS = tmp;

		tmp = leftDeltaS;
		leftDeltaS = rightDeltaS;
		rightDeltaS = tmp;

		tmp = rightT;
		rightT = leftT;
		leftT = tmp;

		tmp = leftDeltaT;
		leftDeltaT = rightDeltaT;
		rightDeltaT = tmp;

		tmp = rightQ;
		rightQ = leftQ;
		leftQ = tmp;

		tmp = leftDeltaQ;
		leftDeltaQ = rightDeltaQ;
		rightDeltaQ = tmp;
	}

	start = y1;

	ok = FALSE;

	leftXFixed = (INT32) ((leftX*COEF_X_FLOAT32)+0.5f);
	leftZFixed = (INT32) ((leftZ*COEF_Z_FLOAT32)+0.5f);
	
	rightXFixed = (INT32) ((rightX*COEF_X_FLOAT32)+0.5f);
	rightZFixed = (INT32) ((rightZ*COEF_Z_FLOAT32)+0.5f);
	
	leftDeltaXFixed = (INT32) (leftDeltaX*COEF_X_FLOAT32);
	leftDeltaZFixed = (INT32) (leftDeltaZ*COEF_Z_FLOAT32);
	
	rightDeltaXFixed = (INT32) (rightDeltaX*COEF_X_FLOAT32);
	rightDeltaZFixed = (INT32) (rightDeltaZ*COEF_Z_FLOAT32);

	if (WindowGet()->isBilinear)
	{
		w = (texWidth<<8)|255;
		h = (texHeight<<8)|255;
	}
		
	do
	{
		y = (INT32) start;
		ySize = (INT32) end-y;

		zy = y*zBufferPitch;
		y *= bufferPitch;

		while (ySize>0)
		{
			x = (leftXFixed+(1<<(BITS_X_SHIFT-1)))>>BITS_X_SHIFT;
			
			bufferOffset = y+x;
			zBufferOffset = zy+x;

			xSize = ((rightXFixed+(1<<(BITS_X_SHIFT-1)))>>BITS_X_SHIFT)-x;

			if (xSize>0)
			{
				deltaZFixed = (rightZFixed-leftZFixed)/xSize;
				deltaS = (rightS-leftS)/xSize;
				deltaT = (rightT-leftT)/xSize;
				deltaQ = (rightQ-leftQ)/xSize;
				
				z = leftZFixed;		
				s = leftS;
				t = leftT;
				q = leftQ;

				bufferLine = &buffer[bufferOffset];			
				zBufferLine = &zBuffer[zBufferOffset];
				
				if (WindowGet()->isBilinear)
				{
					while (xSize>0)
					{
						if (z<=*zBufferLine)
						{
							*zBufferLine = z;
							
							if (q==0.0f)
							{
								u = 0;
								v = 0;
							}
							else
							{
								u = (INT32) ((s*256.0f)/q);
								v = (INT32) ((t*256.0f)/q);

								while (u<0)
								{
									u += w;
								}
								while (v<0)
								{
									v += h;
								}

								while (u>=w)
								{
									u -= w;
								}
								while (v>=h)
								{
									v -= h;
								}
							}
								
							*bufferLine = SoftDrawBilinearGetTexel(texBuffer, texPitch, texHeight, u, v);
						}

						z += deltaZFixed;
						s += deltaS;
						t += deltaT;
						q += deltaQ;
					
						bufferLine++;
						zBufferLine++;

						xSize--;
					}
				}
				else
				{
					while (xSize>0)
					{
						if (z<=*zBufferLine)
						{
							*zBufferLine = z;
							
							if (q==0.0f)
							{
								u = 0;
								v = 0;
							}
							else
							{
								u = (INT32) (s/q);
								v = (INT32) (t/q);

								while (u<0)
								{
									u += texWidth;
								}
								while (v<0)
								{
									v += texHeight;
								}

								while (u>texWidth)
								{
									u -= texWidth;
								}
								while (v>texHeight)
								{
									v -= texHeight;
								}
							}

							*bufferLine = texBuffer[v*texPitch+u];
						}

						z += deltaZFixed;
						s += deltaS;
						t += deltaT;
						q += deltaQ;
					
						bufferLine++;
						zBufferLine++;

						xSize--;
					}
				}
			}

			leftXFixed += leftDeltaXFixed;
			leftZFixed += leftDeltaZFixed;
			leftS += leftDeltaS;
			leftT += leftDeltaT;
			leftQ += leftDeltaQ;

			rightXFixed += rightDeltaXFixed;
			rightZFixed += rightDeltaZFixed;
			rightS += rightDeltaS;
			rightT += rightDeltaT;
			rightQ += rightDeltaQ;

			y += bufferPitch;
			zy += zBufferPitch;

			ySize--;
		}

		if (ok==TRUE)
		{
			ok = FALSE;
		}
		else
		{
			if (y1!=y2 && y2!=y3)
			{
				ok = TRUE;

				firstY = y2-y1;
				secondY = y3-y2;
				
				secondDeltaX = (x3-x2)/secondY;
				secondDeltaZ = (z3-z2)/secondY;
				secondDeltaS = (s3-s2)/secondY;
				secondDeltaT = (t3-t2)/secondY;
				secondDeltaQ = (q3-q2)/secondY;
				
				if (leftDeltaX<secondDeltaX)
				{
					leftXFixed = (INT32) ((x2*COEF_X_FLOAT32)+0.5f);
					leftZFixed = (INT32) ((z2*COEF_Z_FLOAT32)+0.5f);
					leftS = s2;
					leftT = t2;
					leftQ = q2;

					leftDeltaXFixed = (INT32) (secondDeltaX*COEF_X_FLOAT32);
					leftDeltaZFixed = (INT32) (secondDeltaZ*COEF_Z_FLOAT32);
					leftDeltaS = secondDeltaS;
					leftDeltaT = secondDeltaT;
					leftDeltaQ = secondDeltaQ;
				}
				else
				{
					rightXFixed = (INT32) ((x2*COEF_X_FLOAT32)+0.5f);
					rightZFixed = (INT32) ((z2*COEF_Z_FLOAT32)+0.5f);
					rightS = s2;
					rightT = t2;
					rightQ = q2;

					rightDeltaXFixed = (INT32) (secondDeltaX*COEF_X_FLOAT32);
					rightDeltaZFixed = (INT32) (secondDeltaZ*COEF_Z_FLOAT32);
					rightDeltaS = secondDeltaS;
					rightDeltaT = secondDeltaT;
					rightDeltaQ = secondDeltaQ;
				}
				
				start = end;
				end = y3;
			}
			else
			{
				ok = FALSE;
			}
		}
	} while (ok==TRUE);
}