/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * softpreca.h - Software Precaching                                          *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _SOFT_PRECA_
#define _SOFT_PRECA_

/*---------------------------------------------------------------------------- STRUCT */
typedef struct SoftPreca
{
    INT32 *buffer;
	UINT32 *zBuffer;
	
	UINT8 *checkTable;

	INT32 width;
	INT32 height;
} SoftPreca;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
void SoftPrecaOffsetAdd(void);
void SoftPrecaAddValue(UINT32 value, UINT32 count);
UINT32 SoftPrecaGetValue(UINT32 count);

void SoftPrecaInit(BOOL enable, INT32 width, INT32 height, INT8 *sceneFileName, UINT32 speed, UINT32 framesCount);
void SoftPrecaFree(void);
BOOL SoftPrecaIsEnabled(void);

void SoftPrecaReset(void);
void SoftPrecaCountInc(void);
UINT32 SoftPrecaCountGet(void);

SoftPreca* SoftPrecaGet(void);

UINT8* SoftPrecaComputeCheckTable(void);

INT8* SoftPrecaBuildFileName(INT8 *sceneFileName);

void SoftPrecaSetFrame(UINT8 *fileBuffer, FLOAT32 time);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _SOFT_PRECA_ */