/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * softtransf.h - Software Transformations                                    *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _SOFT_TRANSF_
#define _SOFT_TRANSF_

/*---------------------------------------------------------------------------- STRUCT */
typedef struct SoftTransfTriBufferParam
{
    Vertex *vertexBuffer;
	FLOAT32 *uvBuffer;	
	INT32 *indexBuffer;
	INT32 srcTriCount;

	Vertex **dstTriBuffer;
	INT32 *dstBufferCount;
	
	BOOL envmap;
	BOOL doCulling;
	BOOL doTexClipping;
	BOOL skip2DClipping;

} SoftTransfTriBufferParam;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
void SoftTransfBuildVertexBuffer(FLOAT32 *vertices, FLOAT32 *normals, Vertex *dst, INT32 count, BOOL clipTex);
void SoftTransfComputeUVVertexBuffer(Vertex *dst, INT32 count, FLOAT32 *uvBuffer, BOOL envmap);
void SoftTransfBuildTriBuffer(SoftTransfTriBufferParam *param);

void SoftTransfEnablePreca(BOOL enable);

void SoftTransfSetOffsetUV(FLOAT32 u, FLOAT32 v);

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _SOFT_TRANSF_ */