/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * snapshot.c - Snapshot                                                      *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/fileio.h"
#include "texture/tex.h"
#include "platform/os/console.h"
#include "system/snapshot.h"

/*---------------------------------------------------------------------------- LOCAL DEFINES */
#define SNAPSHOT_FILENAME			"jfyeNG_000.tga"
#define SNAPSHOT_FILENAME_EXT_SIZE	4

/*---------------------------------------------------------------------------- LOCAL VARIABLES */
static INT8 fileName[STR_DEFAULT_SIZE];
static INT32 snapShotCount = 1;

static RESULT (*snapshotCodec)(Tex *tex) = NULL;

/*---------------------------------------------------------------------------- SNAPSHOT FILENAME */
INT8*
SnapshotGetFileName(void)
{
    INT8 fileNameCount[STR_DEFAULT_SIZE];
	INT8 number[STR_DEFAULT_SIZE];

	strcpy(fileName, FileIOGetCurrentDirectory());    
    
	strcpy(fileNameCount, SNAPSHOT_FILENAME);
	sprintf(number, "%d", snapShotCount);
	
	memcpy(&fileNameCount[strlen(SNAPSHOT_FILENAME)-SNAPSHOT_FILENAME_EXT_SIZE-strlen(number)], number, strlen(number));
	
	strcat(fileName, fileNameCount);

	return fileName;
}

/*---------------------------------------------------------------------------- REGISTER CODEC */
RESULT 
SnapshotRegisterCodec(RESULT (*func)(Tex *tex))
{
    ConsoleAdd("Registering snapshot codec");
    
    snapShotCount = 1;
	snapshotCodec = func;

    return OK;
}

/*---------------------------------------------------------------------------- SAVE SNAPSHOT */
RESULT
SnapshotSave(Tex *tex)
{
    if (snapshotCodec==NULL)
    {
        return ERR;
    }
    
    snapshotCodec(tex);

	snapShotCount++;

    return OK;
}