/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/******************************************************************************
 * tex.h - Texture                                                            *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _TEX_
#define _TEX_

/*---------------------------------------------------------------------------- ENUM */
typedef enum
{
    ScrollUndef,
    ScrollUp,
    ScrollDown,
    ScrollLeft,
    ScrollRight
} ScrollType;

/*---------------------------------------------------------------------------- STRUCT */
typedef struct Tex
{
    INT32 id;
    INT32 index;

    INT8 fileName[STR_DEFAULT_SIZE];

    INT32 width;
    INT32 height;
    INT32 *buffer;

    INT32 depth;

    ScrollType scrollType;

	BOOL doRGBConvert;
	BOOL doScalePower2;

    struct Tex *next;
    struct Tex *prev;
    struct Tex *parent;
} Tex;

typedef struct TexSettings
{
    BOOL doRGBConvert;
	BOOL doScalePower2;

	INT32 maxPower2;
} TexSettings;

/*---------------------------------------------------------------------------- GLOBAL FUNCTIONS */
RESULT TexInit(TexSettings *settings);
RESULT TexSaveSnapshot(Tex *tex);

RESULT TexAdd(Tex *tex);
RESULT TexFree(Tex *tex);
RESULT TexFreeAll(void);

RESULT TexUploadAllToHard(void);
RESULT TexRemoveAllFromHard(void);

RESULT TexRegisterCodec(INT8 *ext, RESULT (*func)(Tex *tex));

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _TEX_ */