/*
jfyeNG - a Newtek LightWave scene player
Copyright (C) 1998-2003  Arnaud STORQ a.k.a. No Recess/CONDENSE (norecess@planet-d.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <config.h>
/******************************************************************************
 * texjpgtiny.c - JPEG Tiny Texture                                           *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#include "platform/os/console.h"
#include "system/file.h"
#include "system/mem.h"
#include "texture/tex.h"
#include "texture/texjpgtiny.h"
#include "texture/texjpgtinyread.h"

/*---------------------------------------------------------------------------- FLIP */
static RESULT
jpgFlip32(Tex *tex)
{
	INT32 x = 0;
	INT32 y = 0;
	INT32 yScanline = 0;
	UINT32 *buffer32 = NULL;
	UINT32 texel = 0;
    
	buffer32 = (UINT32 *) tex->buffer;

	for (y=0; y<(tex->height>>1); y++)
	{
		for (x=0; x<tex->width; x++)
		{
			yScanline = tex->width*y;

			texel = buffer32[yScanline+x];

			buffer32[yScanline+x] = buffer32[(tex->width*(tex->height-1))-yScanline+x];

			buffer32[(tex->width*(tex->height-1))-yScanline+x] = texel;
		}
	}

	return OK;
}

/*---------------------------------------------------------------------------- JPG LITE */
RESULT
JpgTinyLoad(Tex *tex)
{
    File file;

    if (tex==NULL)
    {
        return ERR_INVALID_PTR;
    }

    if (FileLoad(&file, tex->fileName)!=OK)
    {
        return ERR_OPEN_FILE;
    }

#ifdef PS2
    // ConsoleAdd("TinyJpeg: %s", tex->fileName);
#endif
		
	JpgTinyRead((UINT8 *) file.buffer, (UINT8 **) &tex->buffer, &tex->width, &tex->height, &tex->depth);
    
    FileFree(&file);
    
    if (tex->buffer==NULL)
    {
        return ERR_NOT_ENOUGH_MEM;
    }

	jpgFlip32(tex);
    
    return OK;
}
