/******************************************************************************
 * type.h - Type                                                              *
 ******************************************************************************
 * Project      : jfyeNG                                                      *
 * Author       : Arnaud Storq (norecess@planet-d.net)                        *
 ******************************************************************************/
#ifndef _TYPE_
#define _TYPE_

/*---------------------------------------------------------------------------- TYPEDEF */
#ifndef __cplusplus
typedef short               INT16;
typedef unsigned short      UINT16;
typedef char                INT8;
typedef unsigned char       UINT8;
typedef int                 INT32;
typedef unsigned int        UINT32;
#endif

typedef float               FLOAT32;
typedef double              FLOAT64;

typedef float               T_MATRIX[4][4];
typedef float               T_VEC[4];

extern void VecMatMult(T_VEC *res, T_VEC *in, T_MATRIX *mat);
extern void MatrixDump(T_MATRIX *mat);

/*---------------------------------------------------------------------------- ENUM */
typedef enum
{
    OK                                  = 0,
    ERR                                 = -1,
    ERR_INVALID_PTR                     = -2,
    ERR_OPEN_FILE                       = -3,
    ERR_WRITE_FILE                      = -4,
    ERR_NOT_ENOUGH_MEM                  = -5,
    ERR_ARCHIVE                         = -6,
    ERR_ARCHIVE_SIGNATURE               = -7,
    ERR_ARCHIVE_MISSING_FILE            = -8,
    LOG_SKIPPED                         = -9,
    ERR_PLAYLIST_EMPTY                  = -10,
    ERR_PLAYLIST_FULL                   = -11,
    ERR_PLAYLIST_MISSING                = -12,
    ERR_TGA_BAD_DEPTH                   = -13,
    LWO_SKIPPED                         = -14,
    ERR_RACE_LOAD                       = -15,
    ERR_LWS_LOAD                        = -16,
    ERR_LWO_LOAD                        = -17,	
    ERR_LWO_MULTI_LAYER                 = -18,
    ERR_LWO_TEXTURE                     = -19,
    ERR_LWO_VERSION                     = -20,
    ERR_LWO_INVALID                     = -21,
    ERR_LWO_UVMAP_AND_ENDOMORF          = -22,
	ERR_INVALID_DEPTH                   = -23,
	ERR_BAD_CRC							= -24,
	SKIPPED								= -25
} RESULT;

/*---------------------------------------------------------------------------- DEFINE */
#define STR_DEFAULT_SIZE    192

#define BOOL        INT32
#define	FALSE       0
#define TRUE        1

/*---------------------------------------------------------------------------- END OF DECLARATION */
#endif /* _TYPE_ */
