
#include "Arc.h"

// crap.. but working
#define INT8 char
#define UINT8 unsigned char
#include "config.h"
#include "platform/os/memblock.h"
#include "platform/os/win32/memblock.c"
#include "system/mem.h"
#include "system/mem.c"
#include "system/filepack.h"
#include "system/filepack.c"

//
// constructor
CArchiver::CArchiver()
{
	dwBufferSize = 8;
	pBuffer = new BYTE[dwBufferSize];
	*(DWORD*)pBuffer = '1TAD';
	*(DWORD*)&pBuffer[4] = 0;
	DeleteStackCounter = 0;
}

//
// destructor
CArchiver::~CArchiver()
{	
	delete pBuffer;
	pBuffer = NULL;
	dwBufferSize = 0;
}

//
// add
ARCHIVERESULT CArchiver::AddFile(char *szFilename)
{
	FILE *file;
	DWORD updateheadersize, updateoffset, loop;
	DWORD rawsize, headersize;
	DWORD dwPrevBufferSize;
	BYTE *pTemp;
    UINT8 *packedBuffer = NULL;
    INT32 packedSize = 0;    
	
	// open file
	file = fopen(szFilename,"rb");	
	if (file == NULL) return ARCHIVE_IOERROR;

	// get file size
	fseek(file, 0, SEEK_END);
	rawsize = ftell(file);
	fseek(file, 0, SEEK_SET);

	// allocate temp mem
	pTemp = new BYTE[rawsize];
	if (pTemp == NULL) return ARCHIVE_NOTENOUGHMEM;

	// read raw datas
	fread (pTemp, rawsize, 1, file);

	// close file
	fclose (file);

    FilePack((UINT8 *) pTemp, rawsize, &packedBuffer, &packedSize);
	
	// compute new header size
	headersize = 4 + 4 + 4 + 4 + 4 + (strlen(szFilename)+1); // size of chunk ; used codec ; size of raw datas ; size of packed datas ; file offset ; filename+0

	// realloc mem
	dwPrevBufferSize = dwBufferSize;

    if (packedSize<(INT32) rawsize)
    {
        Realloc(dwPrevBufferSize + headersize + packedSize);
    }
    else
    {
        Realloc(dwPrevBufferSize + headersize + rawsize);
    }

	// update file offsets
	updateheadersize = 0;
	updateoffset = 8;
	for(loop=0; loop<*(DWORD*)&pBuffer[4]; loop++)
	{
		updateoffset += updateheadersize;
		updateheadersize = *(DWORD*)&pBuffer[updateoffset];	
		(*(DWORD*)&pBuffer[updateoffset+24-8]) += headersize;
	}
	
	// header
	if (*(DWORD*)&pBuffer[4] != 0)
	{
		memmove(&pBuffer[8 + headersize], &pBuffer[8], dwPrevBufferSize-8);
	}
	*(DWORD*)&pBuffer[8] = headersize; // size of chunk
	if (packedSize<(INT32) rawsize)
    {
        *(DWORD*)&pBuffer[12] = 1; // used codec
        *(DWORD*)&pBuffer[16] = rawsize;
        *(DWORD*)&pBuffer[20] = packedSize;
    }
    else
    {
        *(DWORD*)&pBuffer[12] = 0; // used codec
        *(DWORD*)&pBuffer[16] = rawsize; // raw size
        *(DWORD*)&pBuffer[20] = 0; // unused
	
    }
	*(DWORD*)&pBuffer[24] = dwPrevBufferSize + headersize; // file offset
	strcpy((char*)&pBuffer[28], szFilename);

    if (packedSize<(INT32) rawsize)
    {
        memcpy(&pBuffer[dwPrevBufferSize + headersize], packedBuffer, packedSize);
    }
    else
    {
        // raw datas
	    memcpy(&pBuffer[dwPrevBufferSize + headersize], pTemp, rawsize);
    }

	// increment the file counter
	(*(DWORD*)&pBuffer[4])++;

	// free temp mem
	delete pTemp;
	
	return ARCHIVE_OK;
}

//
// remove
ARCHIVERESULT CArchiver::RemoveFile(char *szFilename)
{
	DWORD itemcount;
	DWORD updateheadersize, updateoffset, loop;
	DWORD offset, fileoffset;
	DWORD packedsize, rawsize, headersize;
	
	// get file infos
	itemcount = 0;
	headersize = 0;
	offset = 8;
	do
	{
		if (*(DWORD*)&pBuffer[4] == itemcount) return ARCHIVE_FILEDOESNOTEXIST;
	
		offset += headersize;
		headersize = *(DWORD*)&pBuffer[offset];	
		rawsize = *(DWORD*)&pBuffer[offset+16-8];
        packedsize = *(DWORD*)&pBuffer[offset+20-8];
        fileoffset = *(DWORD*)&pBuffer[offset+24-8];
		itemcount++;
	} while ((strcmp(szFilename, (char*)&pBuffer[offset+28-8]) != 0) && (itemcount < *(DWORD*)&pBuffer[4]));

    if (packedsize!=0)
    {
        rawsize=packedsize;
    }
    
    // update file offsets
	updateheadersize = 0;
	updateoffset = 8;
	for(loop=0; loop<*(DWORD*)&pBuffer[4]; loop++)
	{
		updateoffset += updateheadersize;
		updateheadersize = *(DWORD*)&pBuffer[updateoffset];	
		
		if (*(DWORD*)&pBuffer[updateoffset+24-8] < fileoffset)
		{
			(*(DWORD*)&pBuffer[updateoffset+24-8]) -= headersize;
		}
		else
		{
			(*(DWORD*)&pBuffer[updateoffset+24-8]) -= (rawsize + headersize);
		}
	}
	
	// remove raw datas
	if ((fileoffset + rawsize) < dwBufferSize)
	{
		memmove(&pBuffer[fileoffset], &pBuffer[fileoffset+rawsize], dwBufferSize-fileoffset-rawsize);
	}
	
	// remove header
	memmove(&pBuffer[offset], &pBuffer[offset+headersize], dwBufferSize-offset-rawsize-headersize);

	// new size
	dwBufferSize -= (rawsize + headersize); // no need to free mem

	// decrement the file counter
	(*(DWORD*)&pBuffer[4])--;
	
	return ARCHIVE_OK;
}

//
// extract
ARCHIVERESULT CArchiver::ExtractFile(char *szFilename, char *szDestFilename)
{
	FILE *file;
	DWORD itemcount;
	DWORD offset, fileoffset;
    DWORD codec;
	DWORD packedsize, rawsize, headersize;

    INT32 unpackedSize;
    UINT8 *unpackedBuffer = NULL;
	
	// get file infos
	itemcount = 0;
	headersize = 0;
	offset = 8;
	do
	{
		if (*(DWORD*)&pBuffer[4] == itemcount) return ARCHIVE_FILEDOESNOTEXIST;
	
		offset += headersize;
		headersize = *(DWORD*)&pBuffer[offset];	
		rawsize = *(DWORD*)&pBuffer[offset+8];
        packedsize = *(DWORD*)&pBuffer[offset+12];
		codec = *(DWORD*)&pBuffer[offset+4];
		fileoffset = *(DWORD*)&pBuffer[offset+16];
		itemcount++;
	} while ((strcmp(szFilename, (char*)&pBuffer[offset+20]) != 0) && (itemcount < *(DWORD*)&pBuffer[4]));

	// open file
	file = fopen(szDestFilename,"wb");	
	if (file == NULL) return ARCHIVE_IOERROR;

    if (codec==1)
    {
        unpackedSize = FileGetUnpackedSize((UINT8 *) &pBuffer[fileoffset]);
        unpackedBuffer = (UINT8 *) new char[unpackedSize];
    
        FileUnpack((UINT8 *)  &pBuffer[fileoffset], unpackedBuffer);

        fwrite (unpackedBuffer, unpackedSize, 1, file);
    }
    else
    {
        fwrite (&pBuffer[fileoffset], rawsize, 1, file);
    }

	// close file
	fclose (file);
	
	return ARCHIVE_OK;
}

//
// get raw datas of a file
ARCHIVERESULT CArchiver::GetRawDatas(char *szFilename, void **p, DWORD *dwSize)
{
	DWORD itemcount;
	DWORD offset, fileoffset;
	DWORD rawsize, packedsize, headersize;
	
	// get file infos
	itemcount = 0;
	headersize = 0;
	offset = 8;
	do
	{
		if (*(DWORD*)&pBuffer[4] == itemcount) return ARCHIVE_FILEDOESNOTEXIST;
	
		offset += headersize;
		headersize = *(DWORD*)&pBuffer[offset];	
		rawsize = *(DWORD*)&pBuffer[offset+16-8];
		packedsize = *(DWORD*)&pBuffer[offset+20-8];
		fileoffset = *(DWORD*)&pBuffer[offset+24-8];
		itemcount++;
	} while ((strcmp(szFilename, (char*)&pBuffer[offset+28-8]) != 0) && (itemcount < *(DWORD*)&pBuffer[4]));

	// set pointer
	*p = (void*)&pBuffer[fileoffset];

	if (packedsize==0)
    {
        *dwSize = rawsize;
    }
    else
    {
        *dwSize = packedsize;
    }
	
	return ARCHIVE_OK;
}

//
// load
ARCHIVERESULT CArchiver::Load(char *szFilename)
{
	FILE *file;

	// open file
	file = fopen(szFilename,"rb");	
	if (file == NULL) return ARCHIVE_IOERROR;

	// get file size
	fseek(file, 0, SEEK_END);
	dwBufferSize = ftell(file);
	fseek(file, 0, SEEK_SET);

	// update buffer
	delete pBuffer;
	pBuffer = new BYTE[dwBufferSize];

	// read datas
	fread (pBuffer, dwBufferSize, 1, file);

	// close file
	fclose (file);
	
	return ARCHIVE_OK;
}

//
// save
ARCHIVERESULT CArchiver::Save(char *szFilename)
{
	FILE *file;
	
	// open file
	file = fopen(szFilename,"wb");	
	if (file == NULL) return ARCHIVE_IOERROR;
	
	// write datas
	fwrite (pBuffer, dwBufferSize, 1, file);

	// close file
	fclose (file);
	
	return ARCHIVE_OK;
}

//
// realloc
ARCHIVERESULT CArchiver::Realloc(DWORD dwNewSize)
{
	if (dwNewSize < dwBufferSize) return ARCHIVE_INVALIDPARAM;
	
	BYTE *pTemp = new BYTE[dwNewSize];
	if (pTemp == NULL) return ARCHIVE_NOTENOUGHMEM;
	
	memcpy(pTemp, pBuffer, dwBufferSize);
	//memset(&pTemp[dwBufferSize], 0, dwNewSize-dwBufferSize);

	delete pBuffer;
	pBuffer = pTemp;
	
	dwBufferSize = dwNewSize;
	
	return ARCHIVE_OK;
}

//
// get size
DWORD CArchiver::GetSize()
{
	return dwBufferSize;
}

//
// get number of files in the archive
DWORD CArchiver::GetFileCount()
{
	return *(DWORD*)&pBuffer[4];
}

//
// get info
ARCHIVERESULT CArchiver::GetFileInfo(DWORD dwFile, ARCHIVEINFO *pArchiveInfo)
{
	DWORD loop;
	DWORD offset;
	DWORD headersize;
	
	// check if dwFile is correct
	if (dwFile >= *(DWORD*)&pBuffer[4]) return ARCHIVE_INVALIDPARAM;
	
	// update file offsets
	headersize = 0;
	offset = 8;
	for(loop=0; loop<=dwFile; loop++)
	{
		offset += headersize;
		headersize = *(DWORD*)&pBuffer[offset];	

		pArchiveInfo->Codec = *(DWORD*)&pBuffer[offset+12-8];
		pArchiveInfo->RawSize = *(DWORD*)&pBuffer[offset+16-8];
		pArchiveInfo->PackedSize = *(DWORD*)&pBuffer[offset+20-8];
		strcpy(pArchiveInfo->szFilename, (char*)&pBuffer[offset+28-8]);
	}

	return ARCHIVE_OK;
}

//
// get version
DWORD CArchiver::GetVersion(VERSIONINFO VersionInfo)
{
	if(VersionInfo == ARCHIVE_SUBVERSION)
		return(ARCHIVE_SUBVERSION_CONTENT);
	else
		return(ARCHIVE_VERSION_CONTENT);
}