; phat2 - norecess.condense
    	
	nolist
	write direct -1,-1, &c0

magicByte	equ &62
startProgram	equ &1000
	
	org startProgram
	run startProgram

	jp entryPoint

interrupt

	ld ( saveSP + 1 ), sp
	ld sp, startProgram

	push af
 	push bc
	push de
	push hl

blink_delay       
	ld b, 1
      	djnz blink_skip

	ld a, ( currBank )
	push af
	call drawProgressBar
	pop af
	call setBank

	ld a, ( blink_delay + 1 )
	xor 5 xor 2
 	ld b, a
blink_skip
        ld a, b
	ld ( blink_delay + 1 ),a

	pop hl
	pop de
	pop bc
 	pop af
  
saveSP
	ld sp, 0

prevIntPtr
	jp 0
;	ei
; 	ret

entryPoint
	ld a, 1
	call &bc0e
	call &bd19
	ld b, 1
	ld c, b
	call &bc38
	ld a, 0
	ld b, 1
	ld c, b
	call &bc32
	ld a, 1
	ld b, 20
	ld c, b
	call &bc32
	ld a, 2
	ld b, 20
	ld c, b
	call &bc32
	ld a, 3
	ld b, 20
	ld c, b
	call &bc32

	ld bc, &bc06
	out (c), c
	inc b
	ld a, 13
	ld c, a
	out (c), a	
	
	call initProgressBar

	di
	ld hl, ( &39 )
	ld ( prevIntPtr + 1 ), hl
	ld hl, interrupt
	ld ( &39 ), hl
	ei

	ld hl, ( &be7d )
	ld a, ( hl )
	push hl
	push af
	ld hl, &abff
	ld de, &0040
	ld c, &07
	call &bcce
	pop af
	pop hl
	ld ( hl ),a

	ld a, &c0
	call setBank

	ld hl, start3830
	ld de, &3830
	ld bc, end3830 - start3830
	ldir

	ld hl, startFCE0
	ld de, &FCE0
	ld bc, endFCE0 - startFCE0
	ldir

	ld a, &c4
	call setBank
	ld hl, phat2_c4
	ld de, &4000
	call load

	ld a, &c5
	call setBank
	ld hl, phat2_c5
	ld de, &4000
	call load

	ld a, &c6
	call setBank
	ld hl, phat2_c6
	ld de, &4000
	call load

	ld a, &c7
	call setBank
	ld hl, phat2_c7
	ld de, &4000
	call load

	di 
	ld hl, ( prevIntPtr + 1 )
	ld ( &39 ), hl
	;ei

	ld a, &c0
	call setBank
	jp &3830

load
	ld b, ( hl )
	inc hl
	ld ( load1 + 1 ), de
	call &bc77
load1
	ld hl, 0
	call &bc83
	call &bc7a
	ret

setBank
    	ld bc, &7f00
    	out (c), c
    	out (c), a
	ld ( currBank ), a
    	ret
currBank
	defb 0

phat2_c4
	defb 9
	defm "PHAT2.001"
phat2_c5
	defb 9
	defm "PHAT2.002"
phat2_c6
	defb 9
	defm "PHAT2.003"
phat2_c7
	defb 9
	defm "PHAT2.004"

; IN de = dst
; IN bc = size
; IN a = value
clear
	ld h, d
	ld l, e
	dec bc
	inc de
	ld ( hl ), a
	ldir
	ret

clearBank
	call setBank
	ld de, &4000
	ld bc, &4000
	ld a, magicByte
	call clear
	ret

initProgressBar
	ld a, &c4
	call clearBank
	ld a, &c5
	call clearBank
	ld a, &c6
	call clearBank
	ld a, &c7
	call clearBank
	ret

zoneSize equ &340

drawProgressBar
	ld de, &c000 + 880 + 1 + 80

loopProgressBar
	ld a, &c3
	inc a
	cp &c8
	jp z, endProgressBar
	ld ( loopProgressBar + 1 ), a
	
	call setBank

	ld hl, &4000
	ld bc, zoneSize
	ld a, &4000 / zoneSize
checkZone
	push hl
	push af

	ld a, ( hl )
	cp magicByte
	jp z, skipZone
	inc hl
	ld a, ( hl )
	cp magicByte
	jp z, skipZone
	inc hl
	ld a, ( hl )
	cp magicByte
	jp z, skipZone
	inc hl
	ld a, ( hl )
	cp magicByte
	jp z, skipZone
	
	push bc
	push de
	push hl

	ld bc, &800
	ld a, &ff
	ex de, hl

	ld ( hl ), a	
	add hl, bc
	ld ( hl ), a	
	add hl, bc
	ld ( hl ), a	
	add hl, bc
	ld ( hl ), a	
	add hl, bc

	pop hl
	pop de
	pop bc

skipZone
	pop af
	pop hl
	inc de
	add hl, bc
	dec a
	jp nz, checkZone

	jp loopProgressBar

endProgressBar
	ld a, &c3
	ld ( loopProgressBar + 1 ), a
	inc a
	call setBank	
	ret

start3830
	incbin "CODE3830.Z80"
end3830

startFCE0
	incbin "CODEFCE0.Z80"
endFCE0